C     --------------------
      SUBROUTINE FLUX1(NN)
C     --------------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      REAL*8 QFLUX(MAXNN),QSET(MAXNN,MAXSET),FACSET(MAXSTP,MAXSET)
      REAL*8 QPOS(MAXNN),QNEG(MAXNN)
      INTEGER*2 QNODE(MAXNN)
      IR1=11
      IW1=13
C
C     NUMBER OF PUMPING PERIODS AND FACTOR FOR PUMPING
C
      WRITE(*,'(1X,''READING IN FLUX'')')
      READ(IR1,900) NQSET,MAXKNS,FACQ,IECHO1,IECHO2
      WRITE(IW1,901) NQSET,MAXKNS,FACQ,IECHO1,IECHO2
      IF (NQSET.EQ.0) RETURN
 900  FORMAT(2I10,F10.0,2I10)
 901  FORMAT(/1X,'SOURCE AND SINK FLUXES'/1X,22('-')/
     1   1X,'NUMBER OF FLUX DATA SETS                ',I10/
     2   1X,'NUMBER OF TIME STEPS                    ',I10/
     3   1X,'FACTOR FOR NODAL FLUXES                 ',1PE10.2/
     4   1X,'SWITCH FOR ECHO OF INPUT FLUXES         ',I10/
     5   1X,'SWITCH FOR ECHO OF STEP FLUXES          ',I10)
C
C     PUMPAGE DATA SETS
C
      DO 103 J=1,NQSET
      READ(IR1,902) NQ
      DO 110 I=1,NN
      QSET(I,J)=0.0
 110  CONTINUE
      READ(IR1,903) (QNODE(I),QSET(QNODE(I),J),I=1,NQ)
      DO 102 I=1,NN
      QSET(I,J)=QSET(I,J)*FACQ
 102  CONTINUE
      IF (IECHO1.EQ.1) THEN
      WRITE(IW1,904) J
      WRITE(IW1,905) (QNODE(I),QSET(QNODE(I),J),I=1,NQ)
      ENDIF
 103  CONTINUE
C
 902  FORMAT(I10)
 903  FORMAT(I10,F10.0)
 904  FORMAT(/1X,'FLUX SET',I10/1X,18('-')/
     1   1X,6X,'NODE',5X,'QFLUX'/)
 905  FORMAT(1X,I10,1PE10.2)
C
C     TIME-STEP INDICATORS AND MULTIPLIERS
C
      DO 203 I=1,MAXKNS
      READ(IR1,906) (FACSET(I,J),J=1,NQSET)
 203  CONTINUE
      IF (IECHO1.EQ.1) THEN
      WRITE(IW1,907)
      IF (NQSET.LE.5) THEN
      DO 204 I=1,MAXKNS
      WRITE(IW1,908) I,(FACSET(I,J),J=1,NQSET)
 204  CONTINUE
      ELSE
      DO 205 I=1,MAXKNS
      WRITE(IW1,908) I,(FACSET(I,J),J=1,5)
      WRITE(IW1,9087) (FACSET(I,J),J=6,NQSET)
 205  CONTINUE
      ENDIF
      ENDIF
 906  FORMAT(10X,5F10.0)
 907  FORMAT(/1X,'TIME-STEP INDICATORS AND MULTIPLIERS'/1X,37('-')/
     1   1X,6X,'STEP',3X,'FACTORS'/)
 908  FORMAT((1X,I10,5(1PE10.2)))
 9087 FORMAT((1X,10X,5(1PE10.2)))
      RETURN
C
C     END DATA INPUT
C
C     -----------------------------------
      ENTRY FLUX2(QFLUX,SUMF,KNS,IOUT,NN)
C     -----------------------------------
C
C     INITIALIZE VECTOR (QFLUX)
C
      DO 105 I=1,NN
      QFLUX(I)=0.0
 105  CONTINUE
      IF (NQSET.EQ.0) RETURN
C
C     COMPUTE PUMPAGE FOR TIME STEP
C
      DO 104 I=1,NN
      DO 1041 J=1,NQSET
      QFLUX(I)=QFLUX(I)+QSET(I,J)*FACSET(KNS,J)
 1041 CONTINUE
 104  CONTINUE
      RETURN
C
C     ---------------------------------------------
      ENTRY FLUX3(QFLUX,QPOS,QNEG,SUMF,KNS,IOUT,NN)
C     ---------------------------------------------
C
      SUMF=0.0
      IF (NQSET.EQ.0) RETURN
      DO 106 I=1,NN
      SUMF=SUMF+QFLUX(I)
      IF (QFLUX(I).GE.0.0) QPOS(I)=QPOS(I)+QFLUX(I)
      IF (QFLUX(I).LT.0.0) QNEG(I)=QNEG(I)+QFLUX(I)
 106  CONTINUE
C
C     DISPLAY FLUXES FOR STEP
C
      IF (IECHO2.EQ.1 .AND. IOUT.EQ.1) THEN
      WRITE(IW1,909) SUMF
      DO 107 I=1,NN
      IF (QFLUX(I).NE.0.0) WRITE(IW1,910) I,QFLUX(I)
 107  CONTINUE
 909  FORMAT(/1X,'SOURCE AND SINK FLUXES'/1X,22('-')/
     1   1X,'TOTAL FLUXES        ',1PE10.2/
     2   1X,6X,'NODE',5X,'QFLUX'/)
 910  FORMAT(1X,I10,1PE10.2)
      ENDIF
      RETURN
      END
