C     --------------------------------------------------
      SUBROUTINE SHAPE1(KXX,KYY,KZZ,SS,XE,YE,ZE,AE,BE,L)
C     --------------------------------------------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      REAL*8 KXX,KYY,KZZ,XE(4),YE(4),ZE(4),AE(4,4),BE(4,4)
      REAL*8 B(4),C(4),D(4)
C
C     VOLUME INTEGRATIONS
C     RE-ASSIGN NODAL COORDINATES
C
      X1=XE(1)
      X2=XE(2)
      X3=XE(3)
      X4=XE(4)
      Y1=YE(1)
      Y2=YE(2)
      Y3=YE(3)
      Y4=YE(4)
      Z1=ZE(1)
      Z2=ZE(2)
      Z3=ZE(3)
      Z4=ZE(4)
C
C     COFACTORS OF THE VOLUME DETERMINATE
C
      A1=X2*(Y3*Z4-Y4*Z3)-X3*(Y2*Z4-Y4*Z2)+X4*(Y2*Z3-Y3*Z2)
      B(1)=-Y3*Z4+Y4*Z3+Y2*Z4-Y4*Z2-Y2*Z3+Y3*Z2
      B(2)=+Y3*Z4-Y4*Z3-Y1*Z4+Y4*Z1+Y1*Z3-Y3*Z1
      B(3)=-Y2*Z4+Y4*Z2+Y1*Z4-Y4*Z1-Y1*Z2+Y2*Z1
      B(4)=+Y2*Z3-Y3*Z2-Y1*Z3+Y3*Z1+Y1*Z2-Y2*Z1
      C(1)=X3*Z4-X4*Z3-X2*Z4+X4*Z2+X2*Z3-X3*Z2
      C(2)=-X3*Z4+X4*Z3+X1*Z4-X4*Z1-X1*Z3+X3*Z1
      C(3)=X2*Z4-X4*Z2-X1*Z4+X4*Z1+X1*Z2-X2*Z1
      C(4)=-X2*Z3+X3*Z2+X1*Z3-X3*Z1-X1*Z2+X2*Z1
      D(1)=-X3*Y4+X4*Y3+X2*Y4-X4*Y2-X2*Y3+X3*Y2
      D(2)=+X3*Y4-X4*Y3-X1*Y4+X4*Y1+X1*Y3-X3*Y1
      D(3)=-X2*Y4+X4*Y2+X1*Y4-X4*Y1-X1*Y2+X2*Y1
      D(4)=+X2*Y3-X3*Y2-X1*Y3+X3*Y1+X1*Y2-X2*Y1
      VOL=(A1+B(1)*X1+C(1)*Y1+D(1)*Z1)/6.0
      IF (VOL.LE.0.0) WRITE(*,'(1X,''NEGATIVE VOLUME FOR'',I10)') L
C
C     ELEMENT STIFFNESS MATRIX (AE) AND DYNAMIC MATRIX (BE)
C

      DO 201 I=1,4
      DO 200 J=1,4
      AE(I,J)=(KXX*B(I)*B(J)+KYY*C(I)*C(J)+KZZ*D(I)*D(J))/(36.0*VOL)
      BE(I,J)=SS*VOL/20.0
      IF (I.EQ.J) BE(I,J)=BE(I,J)*2.0
 200  CONTINUE
 201  CONTINUE
      RETURN
C
C     ---------------------------
      ENTRY SHAPE2(SY,XE,YE,BE,L)
C     ---------------------------
C
C     AREA INTEGRATIONS
C     RE-ASSIGN NODAL COORDINATES
C
      X1=XE(1)
      X2=XE(2)
      X3=XE(3)
      Y1=YE(1)
      Y2=YE(2)
      Y3=YE(3)
C
C     AREA OF ELEMENT
C
      AREA=(X2*Y3-X3*Y2-X1*Y3+X3*Y1+X1*Y2-X2*Y1)/2.0
      IF (AREA.LE.0.0) WRITE(*,'(1X,''NEGATIVE VOLUME FOR'',I10)') L
C
C     ELEMENT DYNAMIC MATRIX (BE)
C
      DO 506 I=1,3
      DO 505 J=1,3
      BE(I,J)=SY*AREA/12.0
      IF (I.EQ.J) BE(I,J)=BE(I,J)*2.0
 505  CONTINUE
 506  CONTINUE
      RETURN
      END
