C     -----------------
      SUBROUTINE SOLVE1
C     -----------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      REAL*8 G(MAXNN,MAXNB),F(MAXNN),H(MAXNN)
      INTEGER*2 ICOL(MAXNN,MAXNB),IDAG(MAXNN),NCOL(MAXNN)
      IR1=11
      IW1=13
C
      READ(IR1,902) NITER,OMEGA,CLOSE
      WRITE(IW1,901) NITER,OMEGA,CLOSE
 901  FORMAT(/1X,'MATRIX SOLUTION PARAMETERS'/1X,26('-')/
     2   1X,'MAXIMUM ITERATIONS               ',I10/
     3   1X,'RELAXATION FACTOR                ',F10.2/
     4   1X,'CLOSURE CRITERION                ',1PE10.2)
 902  FORMAT(I10,2F10.0)
      RETURN
C
C     -------------------------------------
      ENTRY SOLVE2(G,F,H,NN,ICOL,IDAG,NCOL)
C     --------------------------------------
C
C     BEGIN ITERATIONS
C
      DO 500 ITER=1,NITER
C
C     LOOP OVER ROWS
C
      DIFMAX=0.0
      DO 400 I=1,NN
      SUM=0.0
      ID=IDAG(I)
      NC=NCOL(I)
      DO 300 IC=1,NC
      IF (IC.EQ.ID) GOTO 300
      JJ=ICOL(I,IC)
      SUM=SUM+G(I,IC)*H(JJ)
 300  CONTINUE
      IF (DABS(SUM).LE.1.0D-20) SUM=0.0
      HLAST=H(I)
      H(I)=H(I)+OMEGA*(-SUM+F(I))/G(I,ID)-OMEGA*H(I)
      DIFF=DABS(H(I)-HLAST)
      DIFMAX=DMAX1(DIFF,DIFMAX)
 400  CONTINUE
      IF (ITER.EQ.1) WRITE(*,920) ITER,DIFMAX
      IF (ITER.NE.1) WRITE(*,921) ITER,DIFMAX
C
C     CHECK FOR CONVERGENCE
C
      IF(DIFMAX.LE.CLOSE) GOTO 600
 500  CONTINUE
C
      ITER=ITER-1
 600  WRITE(IW1,900) ITER,DIFMAX
 900  FORMAT(/1X,'NUMBER OF ITERATIONS          ',I10/
     1   1X,'MAXIMUM DIFFERENCE            ',1PE10.2)
 920  FORMAT(' ','ITERATION ',I4,1PE10.2)
 921  FORMAT('+','ITERATION ',I4,1PE10.2)
      RETURN
      END
